mbox series

[bug#55179,WIP,00/30] gnu: rakudo: Update to 2022.04 and packages too.

Message ID 20220429051428.372844-1-paul@apatience.com
Headers show
Series gnu: rakudo: Update to 2022.04 and packages too. | expand

Message

Paul A. Patience April 29, 2022, 5:14 a.m. UTC
This patch series updates Rakudo to the latest version.
It also updates all the packages in gnu/packages/perl6.scm to reflect the name
change from Perl 6 to Raku, and also updates all the packages for which newer
versions are available.

The reason this is a WIP is the following:

--8<---------------cut here---------------start------------->8---
$ raku -MFormat::Lisp
===SORRY!=== Error while compiling:
Type check failed in binding to parameter '$address'; expected Str but got Any (Any)
--8<---------------cut here---------------end--------------->8---

Besides for that (admittedly major) issue, Raku runs fine.

Some other minor issues and comments:

• Building Rakudo results in warnings about bogus entries in RUNPATH, which I
  don't know how to address:

--8<---------------cut here---------------start------------->8---
/gnu/store/j4swlyclrwf2sw334lxpf00ll2d0lw36-rakudo-2022.04/bin/raku: warning: RUNPATH contains bogus entries: ("//gnu/store/1w61hypzwmvxw5fpbnv5kx037qbw216k-moarvm-2022.04/lib")
--8<---------------cut here---------------end--------------->8---

• I was unaware of bug#46352 [1] when I started updating Rakudo, and thus my
  efforts were completely independent of Alexandru-Sergiu Marton's.
  The only relevant difference between our patch series is that mine does not
  package dyncall.
  Perhaps it should.

• In a future patch series, we should rename perl6.scm to raku.scm and all the
  perl6- prefixes to raku-, but note that perl6-tap-harness must be renamed to
  raku-tap-harness6 to reflect the new upstream name.
  The Rakudo build system also needs to be updated, because the prove6 script
  no longer exists.
  The documentation also needs to be updated.

• The PERL6LIB environment variable is deprecated in favor of RAKUDOLIB and
  RAKULIB, but I don't know what that means for native-search-paths.
  But dropping support for PERL6LIB can (and probably should) wait a while.

In conclusion, I'm going to try debugging the module compilation issues, but
keeping in mind that I decided to update Rakudo because I was interested in
learning some form of Perl (I didn't know the packaging rabbit hole I would be
descending into :)), I don't know how much success I will have.
I would appreciate any help or pointers.

Best regards,
Paul

[1]: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=46352

Paul A. Patience (30):
  gnu: moarvm: Remove trailing boolean.
  gnu: nqp: Remove trailing booleans.
  gnu: rakudo: Remove trailing booleans.
  gnu: moarvm: Update to 2022.04.
  gnu: Add nqp-configure.
  gnu: nqp: Update to 2022.04.
  gnu: rakudo: Update to 2022.04.
  gnu: perl6-tap-harness: Update to 0.3.5.
  gnu: perl6-zef: Update to 0.13.8.
  gnu: perl6-terminal-ansicolor: Perl -> Raku.
  gnu: perl6-grammar-debugger: Perl -> Raku.
  gnu: perl6-grammar-profiler-simple: Perl -> Raku.
  gnu: perl6-json: Perl -> Raku.
  gnu: perl6-json-fast: Update to 0.17.
  gnu: Add perl6-json-optin.
  gnu: perl6-json-name: Update to 0.0.6.
  gnu: perl6-json-marshal: Update to 0.0.23.
  gnu: perl6-json-unmarshal: Reindent.
  gnu: perl6-json-class: Update to 0.0.18.
  gnu: perl6-license-spdx: Update to 3.16.0.
  gnu: perl6-meta6: Update to 0.0.26.
  gnu: perl6-mime-base64: Update to 1.2.3.
  gnu: perl6-oo-monitors: Update to 1.1.1.
  gnu: perl6-xml-writer: Perl -> Raku.
  gnu: perl6-svg: Perl -> Raku.
  gnu: perl6-svg-plot: Perl -> Raku.
  gnu: perl6-uri: Update to 0.3.5.
  gnu: perl6-test-meta: Update to 0.0.17.
  gnu: perl6-test-mock: Update to 1.5-0.1130427.
  gnu: Add perl6-format-lisp.

 gnu/packages/perl6.scm             | 906 ++++++++++++++++-------------
 guix/build/rakudo-build-system.scm |   8 +-
 2 files changed, 515 insertions(+), 399 deletions(-)

--
2.36.0